"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationError = exports.validatePlugin = void 0;
var nexus_1 = require("nexus");
var utils_1 = require("nexus/dist/utils");
var error_1 = require("./error");
Object.defineProperty(exports, "ValidationError", { enumerable: true, get: function () { return error_1.ValidationError; } });
var resolver_1 = require("./resolver");
var ValidateResolverImport = utils_1.printedGenTypingImport({
    module: 'nexus-validate',
    bindings: ['ValidateResolver'],
});
var fieldDefTypes = utils_1.printedGenTyping({
    optional: true,
    name: 'validate',
    description: 'Validate mutation arguments.',
    type: 'ValidateResolver<TypeName, FieldName>',
    imports: [ValidateResolverImport],
});
var validatePlugin = function (validateConfig) {
    if (validateConfig === void 0) { validateConfig = {}; }
    return nexus_1.plugin({
        name: 'NexusValidate',
        description: 'The validate plugin provides validation for arguments.',
        fieldDefTypes: fieldDefTypes,
        onCreateFieldResolver: resolver_1.resolver(validateConfig),
    });
};
exports.validatePlugin = validatePlugin;
__exportStar(require("./resolver"), exports);
__exportStar(require("./error"), exports);
